/*************************************************
* Basic Filters Header File                      *
* (C) 1999-2001 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_BASIC_FILTERS_H__
#define OPENCL_BASIC_FILTERS_H__

#include <iosfwd>
#include <cstdio>
#include <opencl/filter.h>

namespace OpenCL {

/*************************************************
* Fork                                           *
*************************************************/
struct Fork : public Filter
   {
   void write(const byte input[], u32bit length) { send(input, length); }
   void set_port(u32bit n) throw(Invalid_Port_Number) { Filter::set_port(n); }
   u32bit total_ports()  const { return Filter::total_ports(); }
   u32bit current_port() const { return Filter::current_port(); }

   Fork(Filter* f1, Filter* f2, Filter* f3 = 0, Filter* f4 = 0) : Filter(4)
      { next[0] = f1; next[1] = f2; next[2] = f3; next[3] = f4; }
   Fork(Filter*[], u32bit);
   };

/*************************************************
* Chain                                          *
*************************************************/
struct Chain : public Filter
   {
   void write(const byte input[], u32bit length) { send(input, length); }

   Chain(Filter* f1 = 0, Filter* f2 = 0, Filter* f3 = 0, Filter* f4 = 0)
      { attach(f1); attach(f2); attach(f3); attach(f4); }
   Chain(Filter*[], u32bit);
   };

}

#endif
