/*************************************************
* Cipher Mode Base Header File                   *
* (C) 1999-2001 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_MODEBASE_H__
#define OPENCL_MODEBASE_H__

#include <string>
#include <opencl/filter.h>
#include <opencl/symkey.h>

namespace OpenCL {

typedef SymmetricKey BlockCipherModeIV;

/*************************************************
* Block Cipher Mode Base Class                   *
*************************************************/
class BlockCipherMode : public Filter
   {
   public:
      std::string name() const { return mode_name; }
      void reset_iv(const BlockCipherModeIV&);
      BlockCipherMode(BlockCipher*, u32bit, const std::string&,
                      const BlockCipherKey&, const BlockCipherModeIV&);
      ~BlockCipherMode() { delete cipher; }
   protected:
      const u32bit BLOCKSIZE, IVSIZE;
      const std::string mode_name;
      BlockCipher* cipher;
      SecureVector<byte> buffer, state;
      u32bit position;
   };

}

#endif
