/*************************************************
* Secure Memory Allocator Source File            *
* (C) 1999-2001 The OpenCL Project               *
*************************************************/

#include <cstring>
#include <cstdlib>
#include <opencl/secalloc.h>
#include <opencl/exceptn.h>

namespace OpenCL {

/*************************************************
* Secure Allocation                              *
*************************************************/
void* DefaultAllocator::allocate(u32bit n) const
   {
   void* ptr = std::malloc(n);
   if(!ptr) throw Exception("SecureAllocator: Ran out of memory");
   std::memset(ptr, 0, n);
   return ptr;
   }

/*************************************************
* Secure Deallocation                            *
*************************************************/
void DefaultAllocator::deallocate(void* ptr, u32bit n) const
   {
   std::memset(ptr, 0, n);
   std::free(ptr);
   }

}
